require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_M88K_CMMU_H_)) {
    eval 'sub _M88K_CMMU_H_ () {1;}' unless defined(&_M88K_CMMU_H_);
    require 'machine/mmu.ph';
    if(defined( &_KERNEL)  && !defined( &_LOCORE)) {
	eval 'sub CMMU_LOCK () { &simple_lock( &cmmu_cpu_lock);}' unless defined(&CMMU_LOCK);
	eval 'sub CMMU_UNLOCK () { &simple_unlock( &cmmu_cpu_lock);}' unless defined(&CMMU_UNLOCK);
	eval 'sub cmmu_init () {( ($cmmu->{cmmu_init_func}));}' unless defined(&cmmu_init);
	eval 'sub setup_board_config () {( ($cmmu->{setup_board_config_func}));}' unless defined(&setup_board_config);
	eval 'sub cpu_configuration_print {
	    local($a) = @_;
    	    eval q(( ($cmmu->{cpu_configuration_print_func}))($a));
	}' unless defined(&cpu_configuration_print);
	eval 'sub cmmu_shutdown_now () {( ($cmmu->{cmmu_shutdown_now_func}));}' unless defined(&cmmu_shutdown_now);
	eval 'sub cmmu_parity_enable () {( ($cmmu->{cmmu_parity_enable_func}));}' unless defined(&cmmu_parity_enable);
	eval 'sub cmmu_cpu_number () {( ($cmmu->{cmmu_cpu_number_func}));}' unless defined(&cmmu_cpu_number);
	eval 'sub cmmu_set_sapr {
	    local($a, $b) = @_;
    	    eval q(( ($cmmu->{cmmu_set_sapr_func}))($a, $b));
	}' unless defined(&cmmu_set_sapr);
	eval 'sub cmmu_set_uapr {
	    local($a) = @_;
    	    eval q(( ($cmmu->{cmmu_set_uapr_func}))($a));
	}' unless defined(&cmmu_set_uapr);
	eval 'sub cmmu_flush_tlb {
	    local($a, $b, $c, $d) = @_;
    	    eval q(( ($cmmu->{cmmu_flush_tlb_func}))($a, $b, $c, $d));
	}' unless defined(&cmmu_flush_tlb);
	eval 'sub cmmu_flush_cache {
	    local($a, $b, $c) = @_;
    	    eval q(( ($cmmu->{cmmu_flush_cache_func}))($a, $b, $c));
	}' unless defined(&cmmu_flush_cache);
	eval 'sub cmmu_flush_inst_cache {
	    local($a, $b, $c) = @_;
    	    eval q(( ($cmmu->{cmmu_flush_inst_cache_func}))($a, $b, $c));
	}' unless defined(&cmmu_flush_inst_cache);
	eval 'sub cmmu_flush_data_cache {
	    local($a, $b, $c) = @_;
    	    eval q(( ($cmmu->{cmmu_flush_data_cache_func}))($a, $b, $c));
	}' unless defined(&cmmu_flush_data_cache);
	eval 'sub dma_cachectl {
	    local($a, $b, $c) = @_;
    	    eval q(( ($cmmu->{dma_cachectl_func}))($a, $b, $c));
	}' unless defined(&dma_cachectl);
	eval 'sub dma_cachectl_pa {
	    local($a, $b, $c) = @_;
    	    eval q(( ($cmmu->{dma_cachectl_pa_func}))($a, $b, $c));
	}' unless defined(&dma_cachectl_pa);
	eval 'sub cmmu_dump_config () {( ($cmmu->{cmmu_dump_config_func}));}' unless defined(&cmmu_dump_config);
	eval 'sub cmmu_show_translation {
	    local($a, $b, $c, $d) = @_;
    	    eval q(( ($cmmu->{cmmu_show_translation_func}))($a, $b, $c, $d));
	}' unless defined(&cmmu_show_translation);
	eval 'sub show_apr {
	    local($ap) = @_;
    	    eval q(( ($cmmu->{show_apr_func}))($ap));
	}' unless defined(&show_apr);
    }
}
1;
